require "R2Point"
require "TkDrawer"

# 
class Figure
  def perimeter
    0.0 
  end
  def perimeter2
    0.0 
  end
  def area
    0.0
  end
  def draw
  end
end
# "H"
class Void < Figure
  def add(p)
    $plus=0
    Point.new(p)
  end
end
# ""
class Point < Figure
  def initialize(p) 
    @p = p
  end
  def add(q)
    @p == q ? self : Segment.new(@p, q)
  end
  def draw
    TkDrawer.drawPoint(@p)
  end
end
# ""
class Segment < Figure
  def initialize(p, q) 
    @p, @q = p, q
    if (2.0*R2Point.distance(@q,@p))!=0
      $plus=1
    end
  end
  def perimeter
    2.0 * @p.dist(@q)
  end
  #PERIMETR2
  def perimeter2
    2.0*R2Point.distance(@q,@p)
  end
  def add(r) 
    return Polygon.new(@p, @q, r) if R2Point.triangle?(@p, @q, r)
    return Segment.new(@p, r)     if @q.inside?(@p, r)
    return Segment.new(r, @q)     if @p.inside?(r, @q) 
    self
  end
  def draw
    TkDrawer.drawLine(@p,@q)
  end
end
# ""
class Polygon < Figure
  attr_reader :perimeter, :area, :perimeter2
  def initialize(a, b, c) 
    @qwe=1
    @points     = b.light?(a,c) ? [a, b, c] : [c, b, a]
    @perimeter  = a.dist(b) + b.dist(c) + c.dist(a)
    @area       = R2Point.area(a, b, c).abs
    @perimeter2 = R2Point.distance(a, b) + R2Point.distance(b, c) + R2Point.distance(a, c)
  if @perimeter2==0 and $plus==1
    @qwe=0
  end
  end
  #   
  def add(t)
    j = i = lightEdge(t)
    unless i.nil?
      while j<@points.size-1 and t.light?(@points[j],@points[j+1]) do j+=1 end
      while i < 0 and t.light?(@points[i-1],@points[i]) do i -= 1 end
      for p in i...j
        @perimeter  -= @points[p].dist(@points[p+1])
        @area       += R2Point.area(t,@points[p],@points[p+1]).abs
        @perimeter2 -= R2Point.distance(@points[p], @points[p+1])
        if @perimeter2==0.0 and $plus==1
          @qwe=0
        end
      end
      @perimeter2        = 0.0 if @perimeter2 < 0.0
      @perimeter         += t.dist(@points[i]) + t.dist(@points[j])
      @points[i+1,j-i-1] = t 
      @points[0,j]       = nil if i < -1
      if @qwe==1
        @perimeter2        = @perimeter2 + R2Point.distance(t, @points[i]) + R2Point.distance(t, @points[j])
        if @perimeter2==0.0 and $plus==1
          @qwe=0
        else
          $plus=1
        end
      else
        @perimeter2 = 0.0
      end
      end
    self
  end
  #  
  def draw
    TkDrawer.drawLines(@points)
  end
  private
  #  ݣ 
  def lightEdge(t)
    for p in -1..(@points.size-2)
      return p if t.light?(@points[p],@points[p+1]) 
    end
    nil
  end
end
